using System;
using System.Collections.Generic;
using System.Text;

namespace MyKarte.Service.Impl
{
    /// <summary>
    /// Attachment C^[tFCX
    /// </summary>
    public interface IAttachment
    {
        /// <summary>
        /// F؂B
        /// </summary>
        /// <param name="args"></param>
        /// <returns>true: OK, false: NG</returns>
        bool Authenticate(string[] args);

        /// <summary>
        /// ID擾B
        /// </summary>
        /// <returns>ID</returns>
        string GetPatient();

        /// <summary>
        /// IDݒ肷B
        /// </summary>
        /// <param name="patientId">ID</param>
        void SetPatient(string patientId);
        
        /// <summary>
        /// type, attribute ݒ肷B
        /// </summary>
        /// <param name="props">type, attribute</param>
        void SetProperties(string[] props);
        
        /// <summary>
        /// t擾B
        /// </summary>
        /// <param name="startDate">Jn</param>
        /// <param name="endDate">I</param>
        /// <param name="diff"></param>
        /// <returns>t</returns>
        DateTime[] GetDates(DateTime startDate, DateTime endDate, bool diff);
        
        /// <summary>
        /// w肵t̃f[^𕶎ƂĎ擾B
        /// </summary>
        /// <param name="date">t</param>
        /// <returns></returns>
        string GetContent(DateTime date);
        
        /// <summary>
        /// w肵t̃f[^t@CƂĎ擾B
        /// </summary>
        /// <param name="date">t</param>
        /// <returns>t@CpX, descriptionId</returns>
        Dictionary<string, string> GetFiles(DateTime date);
    }
}
